/*****************************************************************************
 * HASM64                                                                    *
 *****************************************************************************/

/*****************************************************************************
 * File name:     hasm64.h                                                   *
 * Created:       1997-09-04 by Hampa Hug <hhug@student.ethz.ch>             *
 * Last modified: 2002-08-27 by Hampa Hug <hhug@student.ethz.ch>             *
 * Copyright:     (C) 1997-2002 by Hampa Hug <hhug@student.ethz.ch>          *
 *****************************************************************************/

/*****************************************************************************
 * This program is free software. You can redistribute it and / or modify it *
 * under the terms of the GNU General Public License version 2 as  published *
 * by  the Free Software Foundation.                                         *
 *                                                                           *
 * This program is distributed in the hope  that  it  will  be  useful,  but *
 * WITHOUT  ANY   WARRANTY,   without   even   the   implied   warranty   of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  General *
 * Public License for more details.                                          *
 *****************************************************************************/

/* $Id: hasm64.h 19 2004-03-24 15:29:56Z hampa $ */


#ifndef HASM64_H
#define HASM64_H 1


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "config.h"
#include "symtab.h"
#include "scanner.h"
#include "scan64.h"
#include "codegen.h"
#include "parser.h"
#include "expr.h"


#define ERR_ANY      0
#define ERR_INTERNAL 1
#define ERR_SYNTAX   2


#define prt_msg(str) fprintf (stderr, str); fflush (stderr);
#define prt_msg_1(str, v1) fprintf (stderr, str, v1); fflush (stderr);
#define prt_msg_2(str, v1, v2) fprintf (stderr, str, v1, v2); fflush (stderr);

#define prtv_msg(str) if (h64_verbose) { prt_msg (str); }
#define prtv_msg_1(str, v1) if (h64_verbose) { prt_msg_1 (str, v1); }
#define prtv_msg_2(str, v1, v2) if (h64_verbose) { prt_msg_2 (str, v2); }


char *str_clone (char *str);
char *str_copy (char *dst, char *src, unsigned n);

void err_print (parser_t *par, unsigned err, char *str);


#endif
